From bc7fd41907d7b17d37eef03dc6c60b192cf3a455 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Aug 31 2020 04:10:51 +0000
Subject: [PATCH 779/2232] Merge pull request #273 from dtolnay/built


Remove link-cplusplus dependency from non-Cargo builds
---

diff --git a/BUCK b/BUCK
index 2c60139..0dfa11b 100644
--- a/BUCK
+++ b/BUCK
@@ -6,7 +6,6 @@ rust_library(
     deps = [
         ":core",
         ":macro",
-        "//third-party:link-cplusplus",
     ],
 )
 
diff --git a/BUILD b/BUILD
index 0248173..27c6931 100644
--- a/BUILD
+++ b/BUILD
@@ -7,10 +7,7 @@ rust_library(
         ":cxxbridge-macro",
     ],
     visibility = ["//visibility:public"],
-    deps = [
-        ":core-lib",
-        "//third-party:link-cplusplus",
-    ],
+    deps = [":core-lib"],
 )
 
 rust_binary(
diff --git a/build.rs b/build.rs
index 2aad99f..cecf0e5 100644
--- a/build.rs
+++ b/build.rs
@@ -7,4 +7,5 @@ fn main() {
         .compile("cxxbridge03");
     println!("cargo:rerun-if-changed=src/cxx.cc");
     println!("cargo:rerun-if-changed=include/cxx.h");
+    println!("cargo:rustc-cfg=built_with_cargo");
 }
diff --git a/src/lib.rs b/src/lib.rs
index dc26f67..4053c85 100644
--- a/src/lib.rs
+++ b/src/lib.rs
@@ -368,6 +368,7 @@
     clippy::useless_let_if_seq
 )]
 
+#[cfg(built_with_cargo)]
 extern crate link_cplusplus;
 
 #[macro_use]
diff --git a/third-party/BUCK b/third-party/BUCK
index 95c879a..86e8e72 100644
--- a/third-party/BUCK
+++ b/third-party/BUCK
@@ -39,12 +39,6 @@ rust_library(
 )
 
 rust_library(
-    name = "link-cplusplus",
-    srcs = glob(["vendor/link-cplusplus-1.0.2/src/**"]),
-    visibility = ["PUBLIC"],
-)
-
-rust_library(
     name = "proc-macro2",
     srcs = glob(["vendor/proc-macro2-1.0.19/src/**"]),
     visibility = ["PUBLIC"],
diff --git a/third-party/BUILD b/third-party/BUILD
index 081737e..7ceec9b 100644
--- a/third-party/BUILD
+++ b/third-party/BUILD
@@ -44,12 +44,6 @@ rust_library(
 )
 
 rust_library(
-    name = "link-cplusplus",
-    srcs = glob(["vendor/link-cplusplus-1.0.2/src/**"]),
-    visibility = ["//visibility:public"],
-)
-
-rust_library(
     name = "proc-macro2",
     srcs = glob(["vendor/proc-macro2-1.0.19/src/**"]),
     crate_features = [

